U++ - Bug #185
Investigate weird QTF formatting (why is Udaj centered?)
11/25/2011 01:42 PM - Miroslav Fidler
Assignee: % Done: 0%
Category: Estimated time: 0.00 hour
Target version: Spent time: 0.00 hour
Description

[{{3:1:1:1:1:1@L [> Udaj]:: [= Zobrazeni:: Kliky:: CTR:: Cena:: CPC]:@W [< V obdobi 23.10.2011 - 22.11.2011:: ][> 7483:: 399:: 5.33%::
1313.68:: 3.29]::@W [< Od za?atku kampan? do 22.11.2011:: ][> 70956:: 4792:: 6.75%:: 15231.57:: 3.18]::@W [< Celkovy rozpo?et]:: [>
:::::20000.00:: ::@W [< Zbyva z rozpo?tu]:: [> i i1 4768.43:: [:@W [< Garantovany po?et klik?]:: [> :: 500:: :: :: :@W [< Zbyva z
rozpo?tul:: [> i1 -4292:: :: 1 [}}&]&[= [ $$0,0#00000000000000000000000000000000:Default]

History

#1 - 11/26/2011 06:31 PM - Sender Ghost

why is Udaj centered?

Because of "[= [ $$0,0#00000000000000000000000000000000:Default]".
"[=" - align center paragraph, which applies to default style with "00000000000000000000000000000000" uuid.

Seems, default "[= " align applies to other aligns ("[< ") , except "[> " and "[# ".
The same with "[> " align, which applies to other aligns ("[< "), except "[=", "[#".

Which leads to following code:

if(!l.withtabs)
switch(format.align) {
case ALIGN_RIGHT:
|.xpos += cx - l.cx;
break;
case ALIGN_CENTER:
|.xpos += (cx - l.cx) / 2;

break;

Simplified test cases:

[ {{ [# Justify]:: [< Left ]:: [= Center ]:: [> Right]}}]1&
[ $$0,0#00000000000000000000000000000000:Default]

[{ [# Justify]:: [< Left ]:: [= Center ]:: [> Right]}]&
[= $$0,0#00000000000000000000000000000000:Default]
/redmine/projects/upp/repository/revisions/2167/entry/trunk/uppsrc/RichText/ParaType.cpp#L26

[ {{ [# Justify]:: [< Left ]:: [= Center ]:: [> Right]}}]1&
[> $$0,0#00000000000000000000000000000000:Default]

#2 - 11/30/2011 10:21 PM - Sender Ghost

There is also another simplified test case:
-= $$0,0#00000000000000000000000000000000:Default]
[ {{ [ Text]:: [# Justify]:: [< Left]:: [= Center]:: [> Right]}}]&

[-*> $$0,0#00000000000000000000000000000000:Default]&
[{{ [ Text]:: [# Justify]:: [< Left]:: [= Center]:: [> Right]}}]

Seems, this is due to merging of styles after target.SetStyle(id, style); for Default style.

#3 - 05/17/2012 07:35 PM - Miroslav Fidler
- Priority changed from Normal to High

#4 - 08/05/2012 09:37 AM - Miroslav Fidler

- Status changed from New to Rejected
/redmine/projects/upp/repository/revisions/3828/entry/trunk/uppsrc/RichText/ParseQtf.cpp#L871

